searchNodes=[{"doc":"A queue implementation using MongoDB. Inspired by the NPM mongodb-queue package .","ref":"MongoQueue.html","title":"MongoQueue","type":"module"},{"doc":"Marks a message as acknowledged, making it unavailable to be received from the queue in the future. Acknowledged messages may eventually be deleted, using the clean/1 function. Parameters config - A queue configuration. ack_or_acks - The ack ID of the message to acknowledge, or a list of ack IDs to acknowledge. opts - Additional options, to override those found in the config parameter. Examples iex&gt; MongoQueue . ack ( config , ack ) :ok iex&gt; MongoQueue . ack ( config , [ ack1 , ack2 ] ) :ok","ref":"MongoQueue.html#ack/3","title":"MongoQueue.ack/3","type":"function"},{"doc":"Adds a message to the queue. Examples iex&gt; MongoQueue . add ( config , %{ foo : &quot;bar&quot; } ) { :ok , # BSON.ObjectId &lt; 5 f0e1e1b0000000000000000 &gt; } iex&gt; MongoQueue . add ( config , %{ foo : &quot;bar&quot; } , delay : 60 ) { :ok , # BSON.ObjectId &lt; 5 f0e1e1b0000000000000000 &gt; }","ref":"MongoQueue.html#add/3","title":"MongoQueue.add/3","type":"function"},{"doc":"Adds multiple messages to the queue. Examples iex&gt; MongoQueue . add_many ( config , [ %{ foo : &quot;bar&quot; } , %{ foo : &quot;baz&quot; } ] ) { :ok , [ # BSON.ObjectId &lt; 5 f0e1e1b0000000000000000 &gt; , # BSON.ObjectId &lt; 5 f0e1e1b0000000000000001 &gt; ] } iex&gt; MongoQueue . add_many ( config , [ %{ foo : &quot;bar&quot; } , %{ foo : &quot;baz&quot; } ] , delay : 60 ) { :ok , [ # BSON.ObjectId &lt; 5 f0e1e1b0000000000000000 &gt; , # BSON.ObjectId &lt; 5 f0e1e1b0000000000000001 &gt; ] }","ref":"MongoQueue.html#add_many/3","title":"MongoQueue.add_many/3","type":"function"},{"doc":"Removes acknowledged documents from the queue collection. Messages remain in the MongoDB collection until they are deleted by this function.","ref":"MongoQueue.html#clean/1","title":"MongoQueue.clean/1","type":"function"},{"doc":"Creates indexes to ensure high performance for the queue. This only needs to be run once per queue.","ref":"MongoQueue.html#create_indexes/1","title":"MongoQueue.create_indexes/1","type":"function"},{"doc":"Returns the number of messages that have been acknowledged but not yet deleted.","ref":"MongoQueue.html#done/1","title":"MongoQueue.done/1","type":"function"},{"doc":"Gets a payload from the queue. Examples iex&gt; MongoQueue . get ( config ) { :ok , %{ id : # BSON.ObjectId &lt; 5 f0e1e1b0000000000000000 &gt; , ack : # BSON.ObjectId &lt; 5 f0e1e1b0000000000000001 &gt; , payload : %{ foo : &quot;bar&quot; } } } iex&gt; MongoQueue . get ( config ) { :ok , nil }","ref":"MongoQueue.html#get/2","title":"MongoQueue.get/2","type":"function"},{"doc":"Gets multiple messages from the queue. Warning This operation performs a multi-document transaction. In MongoDB, this requires a replica set. To learn more, check out MongoDB’s documentation . Parameters config - A queue configuration. count - The maximum number of messages to retrieve. If fewer than this number of messages are available, a smaller amount will be received. opts - Additional options, to override those found in the config parameter. Examples iex&gt; MongoQueue . get_many ( config , 2 ) { :ok , [ %{ id : # BSON.ObjectId &lt; 5 f0e1e1b0000000000000000 &gt; , ack : # BSON.ObjectId &lt; 5 f0e1e1b0000000000000001 &gt; , payload : %{ foo : &quot;bar&quot; } } , %{ id : # BSON.ObjectId &lt; 5 f0e1e1b0000000000000002 &gt; , ack : # BSON.ObjectId &lt; 5 f0e1e1b0000000000000003 &gt; , payload : %{ foo : &quot;baz&quot; } } ] } iex&gt; MongoQueue . get_many ( config , 2 ) { :ok , [ ] }","ref":"MongoQueue.html#get_many/3","title":"MongoQueue.get_many/3","type":"function"},{"doc":"Returns the number of messages that have been received from the queue but not yet acknowledged.","ref":"MongoQueue.html#in_flight/1","title":"MongoQueue.in_flight/1","type":"function"},{"doc":"Marks a message as not acknowledged, making it immediately available to be received from the queue again. Examples iex&gt; MongoQueue . nack ( config , ack ) :ok","ref":"MongoQueue.html#nack/3","title":"MongoQueue.nack/3","type":"function"},{"doc":"Extends the visibility timeout of a received message. This allows long-running tasks to operate on a message without the risk of it being received by another process. Examples iex&gt; MongoQueue . ping ( config , ack ) :ok","ref":"MongoQueue.html#ping/3","title":"MongoQueue.ping/3","type":"function"},{"doc":"Returns the number of enqueued, visible messages in the queue’s collection.","ref":"MongoQueue.html#size/1","title":"MongoQueue.size/1","type":"function"},{"doc":"Returns the total number of messages in the queue’s collection—regardless of their status.","ref":"MongoQueue.html#total/1","title":"MongoQueue.total/1","type":"function"},{"doc":"","ref":"MongoQueue.html#t:message/0","title":"MongoQueue.message/0","type":"type"},{"doc":"Configuration for a queue. Struct Properties conn - A MongoDB connection, from the mongodb_driver package . collection - The name of the collection to use for the queue. visibility_timeout - The amount of time in seconds that a message is invisible after it has been received from the queue. delay - The amount of time in seconds that a message is delayed before it is available to be received from the queue.","ref":"MongoQueue.Config.html","title":"MongoQueue.Config","type":"module"},{"doc":"Merges the given options into the configuration. Examples iex&gt; MongoQueue.Config . new ( conn , &quot;my_queue&quot; ) |&gt; MongoQueue.Config . merge ( visibility_timeout : 60 ) % MongoQueue.Config { conn : # PID &lt; 0 . 123 . 0 &gt; , collection : &quot;my_queue&quot; , visibility_timeout : 60 , delay : 0 }","ref":"MongoQueue.Config.html#merge/2","title":"MongoQueue.Config.merge/2","type":"function"},{"doc":"Creates a new queue configuration. Examples iex&gt; MongoQueue.Config . new ( conn , &quot;my_queue&quot; ) % MongoQueue.Config { conn : # PID &lt; 0 . 123 . 0 &gt; , collection : &quot;my_queue&quot; , visibility_timeout : 30 , delay : 0 }","ref":"MongoQueue.Config.html#new/3","title":"MongoQueue.Config.new/3","type":"function"},{"doc":"","ref":"MongoQueue.Config.html#t:t/0","title":"MongoQueue.Config.t/0","type":"type"}]